using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductCategory;
namespace CMSMicroservice.Protobuf.Validator.ProductCategory;

public class GetProductCategoryRequestValidator : AbstractValidator<GetProductCategoryRequest>
{
    public GetProductCategoryRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetProductCategoryRequest>.CreateWithOptions((GetProductCategoryRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
